/* terminal.vala
 *
 * Copyright (C) 2010  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

using Valide;

public class TerminalPlugin : Plugin, Object
{
  /**
   * @see Plugin.path
   */
  public string path { get; construct set; }
  /**
   * @see Plugin.window
   */
  public Window window { get; construct set; }

  private Gtk.ScrolledWindow scrolled_window;
  private Vte.Terminal terminal;

  construct
  {
    this.scrolled_window = new Gtk.ScrolledWindow (null, null);

    this.scrolled_window.set_policy (Gtk.PolicyType.AUTOMATIC,
                                     Gtk.PolicyType.AUTOMATIC);

    this.terminal = new Vte.Terminal ();
    this.scrolled_window.add (this.terminal);

    try
    {
      Utils.register_icon (Path.build_filename (Config.PIXMAPS_DIR,
                                                "plugins",
                                                "terminal.png"),
                           "terminal-plugin-icon");
    }
    catch (Error e)
    {
      debug (e.message);
    }
    this.window.add_widget (this.scrolled_window, "terminal-plugin",
                            _("Terminal"), Window.Placement.BOTTOM,
                            "terminal-plugin-icon");
  }

  ~TerminalPlugin ()
  {
    this.window.remove_widget (this.scrolled_window);
  }
}

[ModuleInit]
public Type register_plugin (void* user_data) throws PluginError
{
  /** @tod Check if VTE is installed */
  return typeof (TerminalPlugin);
}

